#include <stdio.h>
#include <stdlib.h>
#include "useful.h"

void print (char *a, int cont, int n)
{
	int i, j;
	for (i = cont, j = 1; i < n; i++, j++)
	{
		printf ("%c", a[i]);
		if (j%80 == 0)
			printf ("\n");
	}
	for (i = 0; i < cont; i++, j++)
	{
		printf ("%c", a[i]);
		if (j%80 == 0)
			printf ("\n");
	}
}

void main (int argc, char* argv[])
{
	FILE *in;
	int n, id, i;
	char *a, c;
	bool go;
	if (argc != 3 || !is_numeric (argv[2]))
	{
		printf ("Usage %s <input file name> <length>\n", argv[0]);
		exit(0);
	}
	in = fopen (argv[1], "r");
	if (in == NULL)
	{
		printf ("File %s not found\n", argv[1]);
		exit(0);
	}
	n = atoi (argv[2]);
	a = new char[n];
	for (c = get (in); c != EOF;)
	{
		fscanf (in, "%d", &id);
		for (c = getc(in); c != '\n'; c = getc(in));
		for (i = 0, go = true; i < n && go; i++)
		{
			a[i] = get (in);
			if (a[i] == '>' || a[i] == EOF)
				go = false;
		}
		if (go)
		{
			printf ("> %d 0\n", id);
			print (a, 0, n);
			if (n%80 != 0)
				printf ("\n");
			for (c = get(in), i = 0; c != '>' && c != EOF; c = get(in), i++)
			{
				a[i%n] = c;
				printf ("> %d %d\n", id, i+1);
				print (a, (i+1)%n, n);
				if (n%80 != 0)
					printf ("\n");
			}
		}
	}
}
