#include <stdio.h>
#include <stdlib.h>
#include "useful.h"

char reverse (char a)
{
	if (a == 'A')
		return 'T';
	if (a == 'T')
		return 'A';
	if (a == 'C')
		return 'G';
	if (a == 'G')
		return 'C';
	return 'N';
}

void print (int seq, int start, char *a, int n, bool foward)
{
	int i, j;
	if (foward)
	{
		printf ("> %d %d %d\n", seq, start, start + n - 1);
		for (i = start % n, j = 1; i < n; i++, j++)
		{
			printf ("%c", a[i]);
			if (j%80 == 0)
				printf ("\n");
		}
		for (i = 0; i < start % n; i++, j++)
		{
			printf ("%c", a[i]);
			if (j%80 == 0)
				printf ("\n");
		}
	}
	else
	{
		printf ("> %d %d %d\n", seq, start + n - 1, start);
		for (i = (start + n - 1) % n, j = 1; i >= 0; i--, j++)
		{
			printf ("%c", reverse(a[i]));
			if (j%80 == 0)
				printf ("\n");
		}
		for (i = n - 1; i >= (start + n - 1) % n + 1; i--, j++)
		{
			printf ("%c", reverse(a[i]));
			if (j%80 == 0)
				printf ("\n");
		}
	}
}

int main (int argc, char* argv[])
{
	FILE *in;
	int n, id, i;
	char *a, c;
	bool go, foward;
	if (argc != 4 || !is_numeric (argv[2]) || (strcmp (argv[3], "-f") && strcmp (argv[3], "-r")))
	{
		printf ("Usage %s <input file name> <length> <-f forward or -r reverse>\n", argv[0]);
		exit(0);
	}
	in = fopen (argv[1], "r");
	if (in == NULL)
	{
		printf ("File %s not found\n", argv[1]);
		exit(0);
	}
	n = atoi (argv[2]);
	foward = strcmp (argv[3], "-f")? false: true;
	a = new char[n];
	for (c = get (in); c != EOF;)
	{
		fscanf (in, "%d", &id);
		for (c = getc(in); c != '\n'; c = getc(in));
		for (i = 0, go = true; i < n && go; i++)
		{
			a[i] = get (in);
			if (a[i] == '>' || a[i] == EOF)
                        {
				c = a[i];
                                go = false;
    			}
		}
		if (go)
		{
// 			printf ("> %d 0\n", id);
			print (id, 0, a, n, foward);
			if (n%80 != 0)
				printf ("\n");
			for (c = get(in), i = 0; c != '>' && c != EOF; c = get(in), i++)
			{
				a[i%n] = c;
// 				printf ("> %d %d\n", id, i+1);
				print (id, i+1, a, n, foward);
				if (n%80 != 0)
					printf ("\n");
			}
		}
	}
	return 0;
}
